The Google Drive API allows clients to access resources from Google Drive.

- [REST Resource: v3.about](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.about)
- [REST Resource: v3.accessproposals](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.accessproposals)
- [REST Resource: v3.approvals](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.approvals)
- [REST Resource: v3.apps](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.apps)
- [REST Resource: v3.changes](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.changes)
- [REST Resource: v3.channels](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.channels)
- [REST Resource: v3.comments](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.comments)
- [REST Resource: v3.drives](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.drives)
- [REST Resource: v3.files](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.files)
- [REST Resource: v3.operations](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.operations)
- [REST Resource: v3.permissions](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.permissions)
- [REST Resource: v3.replies](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.replies)
- [REST Resource: v3.revisions](https://developers.google.com/workspace/drive/api/reference/rest/v3#v3.revisions)

## Service: googleapis.com/drive/v3

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://www.googleapis.com/discovery/v1/apis/drive/v3/rest>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://www.googleapis.com`

## REST Resource: [v3.about](https://developers.google.com/workspace/drive/api/reference/rest/v3/about)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/about/get` | `GET /drive/v3/about` Gets information about the user, the user's Drive, and system capabilities. |

## REST Resource: [v3.accessproposals](https://developers.google.com/workspace/drive/api/reference/rest/v3/accessproposals)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/accessproposals/get` | `GET /drive/v3/files/{fileId}/accessproposals/{proposalId}` Retrieves an access proposal by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/accessproposals/list` | `GET /drive/v3/files/{fileId}/accessproposals` List the access proposals on a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/accessproposals/resolve` | `POST /drive/v3/files/{fileId}/accessproposals/{proposalId}:resolve` Approves or denies an access proposal. |

## REST Resource: [v3.approvals](https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/approve` | `POST /drive/v3/files/{fileId}/approvals/{approvalId}:approve` Approves an approval. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/cancel` | `POST /drive/v3/files/{fileId}/approvals/{approvalId}:cancel` Cancels an approval. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/comment` | `POST /drive/v3/files/{fileId}/approvals/{approvalId}:comment` Comments on an approval. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/decline` | `POST /drive/v3/files/{fileId}/approvals/{approvalId}:decline` Declines an approval. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/get` | `GET /drive/v3/files/{fileId}/approvals/{approvalId}` Gets an approval by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/list` | `GET /drive/v3/files/{fileId}/approvals` Lists the approvals on a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/reassign` | `POST /drive/v3/files/{fileId}/approvals/{approvalId}:reassign` Reassigns the reviewers on an approval. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/approvals/start` | `POST /drive/v3/files/{fileId}/approvals:start` Starts an approval on a file. |

## REST Resource: [v3.apps](https://developers.google.com/workspace/drive/api/reference/rest/v3/apps)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/apps/get` | `GET /drive/v3/apps/{appId}` Gets a specific app. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/apps/list` | `GET /drive/v3/apps` Lists a user's installed apps. |

## REST Resource: [v3.changes](https://developers.google.com/workspace/drive/api/reference/rest/v3/changes)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/changes/getStartPageToken` | `GET /drive/v3/changes/startPageToken` Gets the starting pageToken for listing future changes. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/changes/list` | `GET /drive/v3/changes` Lists the changes for a user or shared drive. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/changes/watch` | `POST /drive/v3/changes/watch` Subscribes to changes for a user. |

## REST Resource: [v3.channels](https://developers.google.com/workspace/drive/api/reference/rest/v3/channels)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/channels/stop` | `POST /drive/v3/channels/stop` Stops watching resources through this channel. |

## REST Resource: [v3.comments](https://developers.google.com/workspace/drive/api/reference/rest/v3/comments)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/comments/create` | `POST /drive/v3/files/{fileId}/comments` Creates a comment on a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/comments/delete` | `DELETE /drive/v3/files/{fileId}/comments/{commentId}` Deletes a comment. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/comments/get` | `GET /drive/v3/files/{fileId}/comments/{commentId}` Gets a comment by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/comments/list` | `GET /drive/v3/files/{fileId}/comments` Lists a file's comments. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/comments/update` | `PATCH /drive/v3/files/{fileId}/comments/{commentId}` Updates a comment with patch semantics. |

## REST Resource: [v3.drives](https://developers.google.com/workspace/drive/api/reference/rest/v3/drives)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/create` | `POST /drive/v3/drives` Creates a shared drive. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/delete` | `DELETE /drive/v3/drives/{driveId}` Permanently deletes a shared drive for which the user is an `organizer`. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/get` | `GET /drive/v3/drives/{driveId}` Gets a shared drive's metadata by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/hide` | `POST /drive/v3/drives/{driveId}/hide` Hides a shared drive from the default view. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/list` | `GET /drive/v3/drives` <br /> Lists the user's shared drives. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/unhide` | `POST /drive/v3/drives/{driveId}/unhide` Restores a shared drive to the default view. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/drives/update` | `PATCH /drive/v3/drives/{driveId}` Updates the metadata for a shared drive. |

## REST Resource: [v3.files](https://developers.google.com/workspace/drive/api/reference/rest/v3/files)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/copy` | `POST /drive/v3/files/{fileId}/copy` Creates a copy of a file and applies any requested updates with patch semantics. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/create` | `POST /drive/v3/files` `POST /upload/drive/v3/files` <br /> Creates a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/delete` | `DELETE /drive/v3/files/{fileId}` Permanently deletes a file owned by the user without moving it to the trash. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/download` | `POST /drive/v3/files/{fileId}/download` Downloads the content of a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/emptyTrash` | `DELETE /drive/v3/files/trash` Permanently deletes all of the user's trashed files. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/export` | `GET /drive/v3/files/{fileId}/export` Exports a Google Workspace document to the requested MIME type and returns exported byte content. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/generateCseToken` | `GET /drive/v3/files/generateCseToken` Generates a CSE token which can be used to create or update CSE files. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/generateIds` | `GET /drive/v3/files/generateIds` Generates a set of file IDs which can be provided in create or copy requests. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/get` | `GET /drive/v3/files/{fileId}` <br /> Gets a file's metadata or content by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/list` | `GET /drive/v3/files` <br /> Lists the user's files. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/listLabels` | `GET /drive/v3/files/{fileId}/listLabels` Lists the labels on a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/modifyLabels` | `POST /drive/v3/files/{fileId}/modifyLabels` Modifies the set of labels applied to a file. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/update` | `PATCH /drive/v3/files/{fileId}` `PATCH /upload/drive/v3/files/{fileId}` <br /> Updates a file's metadata, content, or both. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/files/watch` | `POST /drive/v3/files/{fileId}/watch` Subscribes to changes to a file. |

## REST Resource: [v3.operations](https://developers.google.com/workspace/drive/api/reference/rest/v3/operations)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/operations/get` | `GET /drive/v3/operations/{name}` Gets the latest state of a long-running operation. |

## REST Resource: [v3.permissions](https://developers.google.com/workspace/drive/api/reference/rest/v3/permissions)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/permissions/create` | `POST /drive/v3/files/{fileId}/permissions` Creates a permission for a file or shared drive. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/permissions/delete` | `DELETE /drive/v3/files/{fileId}/permissions/{permissionId}` Deletes a permission. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/permissions/get` | `GET /drive/v3/files/{fileId}/permissions/{permissionId}` Gets a permission by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/permissions/list` | `GET /drive/v3/files/{fileId}/permissions` Lists a file's or shared drive's permissions. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/permissions/update` | `PATCH /drive/v3/files/{fileId}/permissions/{permissionId}` Updates a permission with patch semantics. |

## REST Resource: [v3.replies](https://developers.google.com/workspace/drive/api/reference/rest/v3/replies)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/replies/create` | `POST /drive/v3/files/{fileId}/comments/{commentId}/replies` Creates a reply to a comment. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/replies/delete` | `DELETE /drive/v3/files/{fileId}/comments/{commentId}/replies/{replyId}` Deletes a reply. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/replies/get` | `GET /drive/v3/files/{fileId}/comments/{commentId}/replies/{replyId}` Gets a reply by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/replies/list` | `GET /drive/v3/files/{fileId}/comments/{commentId}/replies` Lists a comment's replies. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/replies/update` | `PATCH /drive/v3/files/{fileId}/comments/{commentId}/replies/{replyId}` Updates a reply with patch semantics. |

## REST Resource: [v3.revisions](https://developers.google.com/workspace/drive/api/reference/rest/v3/revisions)

| Methods ||
|---|---|
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/revisions/delete` | `DELETE /drive/v3/files/{fileId}/revisions/{revisionId}` Permanently deletes a file version. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/revisions/get` | `GET /drive/v3/files/{fileId}/revisions/{revisionId}` Gets a revision's metadata or content by ID. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/revisions/list` | `GET /drive/v3/files/{fileId}/revisions` Lists a file's revisions. |
| `https://developers.google.com/workspace/drive/api/reference/rest/v3/revisions/update` | `PATCH /drive/v3/files/{fileId}/revisions/{revisionId}` Updates a revision with patch semantics. |